/*            Copyright (C) 2001, 2002, 2003 Stijn van Dongen
 *
 * This file is part of Zoem. You can redistribute and/or modify Zoem under the
 * terms of the GNU General Public License;  either version 2 of the License or
 * (at your option) any later  version.  You should have received a copy of the
 * GPL along with Zoem, in the file COPYING.
*/

#ifndef zoem_key_h
#define zoem_key_h

#include "filter.h"

#include "util/ting.h"
#include "util/io.h"
#include "util/types.h"
#include "util/hash.h"


mcxstatus yamScopePush
(  char *type
)  ;

mcxstatus yamScopePop
(  char *type
)  ;

void  yamKeySet
(  const char* key
,  const char* val
)  ;

void  yamKeyDef
(  const char* key
,  const char* val
)  ;

mcxTing* yamKeyDelete
(  mcxTing*  key
)  ;

mcxTing* yamKeyGet
(  mcxTing*  key
)  ;

mcxTing* yamKeyGetLocal
(  mcxTing*  key
)  ;

mcxTing* yamKeyInsert
(  mcxTing*      key
,  const char*  valstr
)  ;

void yamKeyInitialize
(  int n
)  ;

void yamKeyExit
(  void
)  ;

void yamKeyStats
(  void
)  ;

void yamKeyList
(  const char* mode
)  ;

void yamKeyUlimit
(  int   user
,  int   dollar
)  ;

#endif


